/* Problem URL: https://codeforces.com/contest/2093/problem/G */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (size_t i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (size_t i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) { os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

struct node {
    int nodes[2], count[2];

    node(): count(0) {
        fill(nodes, nodes + 2, 0);
    }

    int& operator[](int i) {
        return nodes[i];
    }
};

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;

        vi array(n);
        cin >> array;

        V<node> bits(1);

        auto add = [&](int i){
            int now = 0;
            for (int j = 30; j >= 0; j--) {
                int bit = (i >> j) & 1;
                if (bits[now][bit] == 0) {
                    bits[now][bit] = bits.size();
                    bits.emplace_back();
                }
                bits[now].count[bit]++;
                now = bits[now][bit];
            }
        };

        auto rem = [&](int i){
            int now = 0;
            for (int j = 30; j >= 0; j--) {
                int bit = (i >> j) & 1;
                bits[now].count[bit]--;
                if (bits[now].count[bit] == 0) {
                    bits[now][bit] = 0;
                    return;
                }
                now = bits[now][bit];
            }
        };

        auto search = [&](int i){
            int now = 0;
            for (int j = 30; j >= 0; j--) {
                int bit = (i >> j) & 1;
                if (bits[now][!bit] == 0) {
                    if (((k >> j) & 1) == 1) {
                        return false;
                    }
                    now = bits[now][bit];
                    continue;
                }

                if (((k >> j) & 1) == 0) {
                    return true;
                }

                now = bits[now][!bit];
            }

            return true;
        };

        int ans = INT32_MAX;

        int l = 0, r = 0;
        add(array[0]);
        while (r < array.size() && l <= r) {
            if (search(array[r])) {
                rmin(ans, r - l + 1);
                rem(array[l]);
                l++;
                continue;
            }

            r++;
            if (r < array.size()) {
                add(array[r]);
            }
        }

        if (r == array.size() && search(array[l])) {
            rmin(ans, r - l + 1);
        }

        cout << (ans == INT32_MAX ? -1 : ans) << '\n';
    }
}
